diff --git a/texture-font.c b/texture-font.c
index be9e9e6..f8f1a12 100644
--- a/texture-font.c
+++ b/texture-font.c
@@ -22,15 +22,17 @@
 #define HRESf 64.f
 #define DPI   72
 
-#undef __FTERRORS_H__
-#define FT_ERRORDEF( e, v, s )  { e, s },
-#define FT_ERROR_START_LIST     {
-#define FT_ERROR_END_LIST       { 0, 0 } };
-const struct {
-    int          code;
-    const char*  message;
-} FT_Errors[] =
+#undef FTERRORS_H_
+#define FT_ERROR_START_LIST     switch ( error_code ) {
+#define FT_ERRORDEF( e, v, s )    case v: return s;
+#define FT_ERROR_END_LIST       }
+// Same signature as the function defined in fterrors.h:
+// https://www.freetype.org/freetype2/docs/reference/ft2-error_enumerations.html#ft_error_string
+const char* FT_Error_String( FT_Error error_code )
+{
 #include FT_ERRORS_H
+    return "INVALID ERROR CODE";
+}
 
 // ------------------------------------------------- texture_font_load_face ---
 static int
@@ -49,9 +51,10 @@ texture_font_load_face(texture_font_t *self, float size,
 
     /* Initialize library */
     error = FT_Init_FreeType(library);
-    if(error) {
-        fprintf(stderr, "FT_Error (0x%02x) : %s\n",
-                FT_Errors[error].code, FT_Errors[error].message);
+    if( error )
+    {
+        fprintf( stderr, "FT_Error (line %d, 0x%02x) : %s\n",
+                 __LINE__, error, FT_Error_String(error) );
         goto cleanup;
     }
 
@@ -67,26 +70,29 @@ texture_font_load_face(texture_font_t *self, float size,
         break;
     }
 
-    if(error) {
-        fprintf(stderr, "FT_Error (line %d, code 0x%02x) : %s\n",
-                __LINE__, FT_Errors[error].code, FT_Errors[error].message);
+    if( error )
+    {
+        fprintf( stderr, "FT_Error (line %d, code 0x%02x) : %s\n",
+                 __LINE__, error, FT_Error_String(error) );
         goto cleanup_library;
     }
 
     /* Select charmap */
     error = FT_Select_Charmap(*face, FT_ENCODING_UNICODE);
-    if(error) {
-        fprintf(stderr, "FT_Error (line %d, code 0x%02x) : %s\n",
-                __LINE__, FT_Errors[error].code, FT_Errors[error].message);
+    if( error )
+    {
+        fprintf( stderr, "FT_Error (line %d, code 0x%02x) : %s\n",
+                 __LINE__, error, FT_Error_String(error) );
         goto cleanup_face;
     }
 
     /* Set char size */
     error = FT_Set_Char_Size(*face, (int)(size * HRES), 0, DPI * HRES, DPI);
 
-    if(error) {
-        fprintf(stderr, "FT_Error (line %d, code 0x%02x) : %s\n",
-                __LINE__, FT_Errors[error].code, FT_Errors[error].message);
+    if( error )
+    {
+        fprintf( stderr, "FT_Error (line %d, code 0x%02x) : %s\n",
+                 __LINE__, error, FT_Error_String(error) );
         goto cleanup_face;
     }
 
@@ -475,7 +481,7 @@ texture_font_load_glyph( texture_font_t * self,
     if( error )
     {
         fprintf( stderr, "FT_Error (line %d, code 0x%02x) : %s\n",
-                 __LINE__, FT_Errors[error].code, FT_Errors[error].message );
+                 __LINE__, error, FT_Error_String(error) );
         FT_Done_Face( face );
         FT_Done_FreeType( library );
         return 0;
@@ -497,8 +503,8 @@ texture_font_load_glyph( texture_font_t * self,
 
         if( error )
         {
-            fprintf(stderr, "FT_Error (0x%02x) : %s\n",
-                    FT_Errors[error].code, FT_Errors[error].message);
+            fprintf( stderr, "FT_Error (line %d, 0x%02x) : %s\n",
+                     __LINE__, error, FT_Error_String(error) );
             goto cleanup_stroker;
         }
 
@@ -512,8 +518,8 @@ texture_font_load_glyph( texture_font_t * self,
 
         if( error )
         {
-            fprintf(stderr, "FT_Error (0x%02x) : %s\n",
-                    FT_Errors[error].code, FT_Errors[error].message);
+            fprintf( stderr, "FT_Error (line %d, 0x%02x) : %s\n",
+                     __LINE__, error, FT_Error_String(error) );
             goto cleanup_stroker;
         }
 
@@ -526,8 +532,8 @@ texture_font_load_glyph( texture_font_t * self,
 
         if( error )
         {
-            fprintf(stderr, "FT_Error (0x%02x) : %s\n",
-                    FT_Errors[error].code, FT_Errors[error].message);
+            fprintf( stderr, "FT_Error (line %d, 0x%02x) : %s\n",
+                     __LINE__, error, FT_Error_String(error) );
             goto cleanup_stroker;
         }
 
@@ -538,8 +544,8 @@ texture_font_load_glyph( texture_font_t * self,
 
         if( error )
         {
-            fprintf(stderr, "FT_Error (0x%02x) : %s\n",
-                    FT_Errors[error].code, FT_Errors[error].message);
+            fprintf( stderr, "FT_Error (line %d, 0x%02x) : %s\n",
+                     __LINE__, error, FT_Error_String(error) );
             goto cleanup_stroker;
         }
 
